DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Private Member Functions | Private Attributes | List of all members
DVPSSoftcopyVOI_PList Class Reference

the list of softcopy VOI LUT items contained in a presentation state (internal use only). More...

## Public Member Functions
| DVPSSoftcopyVOI_PList ()
| default constructor
| DVPSSoftcopyVOI_PList (const DVPSSoftcopyVOI_PList &copy)
| copy constructor
DVPSSoftcopyVOI_PList * | clone ()
| clone method. More...
virtual | ~DVPSSoftcopyVOI_PList ()
| destructor
OFCondition | read (DcmItem &dset)
| reads a list of softcopy VOI LUTs (SoftcopyVOILUTSequence) from a DICOM dataset. More...
OFCondition | write (DcmItem &dset)
| writes the list of softcopy VOI LUTs managed by this object to a DICOM dataset. More...
void | clear ()
| reset the object to initial state. More...
size_t | size () const
| gets the number of softcopy VOI LUTs in this list. More...
OFCondition | createFromImage (DcmItem &dset, DVPSReferencedSeries_PList &allReferences, const char *sopclassUID, const char *instanceUID, DVPSVOIActivation voiActivation)
| creates a default softcopy VOI LUT sequence for a presentation state from a DICOM image. More...
DVPSSoftcopyVOI * | findSoftcopyVOI (const char *instanceUID, unsigned long frame)
| checks if a softcopy VOI LUT item exists for the given image and frame. More...
DVPSSoftcopyVOI * | createSoftcopyVOI (DVPSReferencedSeries_PList &allReferences, const char *sopclassUID, const char *instanceUID, unsigned long frame, unsigned long numberOfFrames, DVPSObjectApplicability applicability)
| finds or creates a softcopy VOI LUT SQ item with an applicability controlled by the applicability, instanceUID and frame parameters. More...
void | removeSoftcopyVOI (DVPSReferencedSeries_PList &allReferences, const char *instanceUID, unsigned long frame, unsigned long numberOfFrames, DVPSObjectApplicability applicability)
| removes the softcopy VOI for a set of references controlled by the applicability, instanceUID and frame parameters. More...

## Private Member Functions
DVPSSoftcopyVOI_PList & | operator= (const DVPSSoftcopyVOI_PList &)
| private undefined assignment operator

## Private Attributes
OFList< DVPSSoftcopyVOI * > | list_
| the list maintained by this object

## Detailed Description

the list of softcopy VOI LUT items contained in a presentation state (internal use only).

This class manages the data structures comprising one complete Softcopy VOI LUT sequence contained in a presentation state object.

## Member Function Documentation

## ◆ clear()

void DVPSSoftcopyVOI_PList::clear | ( |  | ) |

reset the object to initial state.

After this call, the object is in the same state as after creation with the default constructor.

## ◆ clone()

DVPSSoftcopyVOI_PList* DVPSSoftcopyVOI_PList::clone | ( |  | ) |
| inline

clone method.

Returns
  a pointer to a new DVPSSoftcopyVOI_PList object containing a deep copy of this object.

## ◆ createFromImage()

OFCondition DVPSSoftcopyVOI_PList::createFromImage | ( | DcmItem & | dset,
|  | DVPSReferencedSeries_PList & | allReferences,
|  | const char * | sopclassUID,
|  | const char * | instanceUID,
|  | DVPSVOIActivation | voiActivation
| ) |  |

creates a default softcopy VOI LUT sequence for a presentation state from a DICOM image.

If this method returns an error code, the object is in undefined state afterwards.

Parameters

  dset | the DICOM dataset containing the image IOD
  allReferences | list of series/instance references registered for the presentation state.
  sopclassUID | SOP class UID of the current image
  instanceUID | SOP instance UID of the current image
  voiActivation | flag defining how VOI LUTs or VOI window width/center should be handled. Default: Use VOI and prefer VOI LUT from VOI window.

Returns
  EC_Normal upon success, an error code otherwise.

## ◆ createSoftcopyVOI()

DVPSSoftcopyVOI* DVPSSoftcopyVOI_PList::createSoftcopyVOI | ( | DVPSReferencedSeries_PList & | allReferences,
|  | const char * | sopclassUID,
|  | const char * | instanceUID,
|  | unsigned long | frame,
|  | unsigned long | numberOfFrames,
|  | DVPSObjectApplicability | applicability
| ) |  |

finds or creates a softcopy VOI LUT SQ item with an applicability controlled by the applicability, instanceUID and frame parameters.

The softcopy VOI LUT sequence is rearranged such that all other referenced images/frames keep their old settings.

Parameters

  allReferences | list of series/instance references registered for the presentation state.
  sopclassUID | SOP class UID of the current image
  instanceUID | SOP instance UID of the current image
  frame | number of the current frame
  numberOfFrames | number of frames of the current image
  applicability | applicability of the new softcopy VOI LUT

Returns
  pointer to a softcopy VOI LUT object from the list that matches the applicability parameters. NULL is returned if out of memory.

## ◆ findSoftcopyVOI()

DVPSSoftcopyVOI* DVPSSoftcopyVOI_PList::findSoftcopyVOI | ( | const char * | instanceUID,
|  | unsigned long | frame
| ) |  |

checks if a softcopy VOI LUT item exists for the given image and frame.

Parameters

  instanceUID | SOP instance UID of the current image
  frame | number of the current frame

Returns
  pointer to the softcopy VOI LUT item if it exists, NULL otherwise.

## ◆ read()

OFCondition DVPSSoftcopyVOI_PList::read | ( | DcmItem & | dset | ) |

reads a list of softcopy VOI LUTs (SoftcopyVOILUTSequence) from a DICOM dataset.

The DICOM elements of the softcopy VOI LUT item are copied from the dataset to this object. The completeness of all items (presence of all required elements, value multiplicity) is checked. If this method returns an error code, the object is in undefined state afterwards.

Parameters

  dset | the DICOM dataset from which the sequence is to be read

Returns
  EC_Normal if successful, an error code otherwise.

## ◆ removeSoftcopyVOI()

void DVPSSoftcopyVOI_PList::removeSoftcopyVOI | ( | DVPSReferencedSeries_PList & | allReferences,
|  | const char * | instanceUID,
|  | unsigned long | frame,
|  | unsigned long | numberOfFrames,
|  | DVPSObjectApplicability | applicability
| ) |  |

removes the softcopy VOI for a set of references controlled by the applicability, instanceUID and frame parameters.

The softcopy VOI LUT sequence is rearranged such that all other referenced images/frames keep their old settings.

Parameters

  allReferences | list of series/instance references registered for the presentation state.
  instanceUID | SOP instance UID of the current image
  frame | number of the current frame
  numberOfFrames | number of frames of the current image
  applicability | applicability of the VOI LUT removal

## ◆ size()

size_t DVPSSoftcopyVOI_PList::size | ( |  | ) | const
| inline

gets the number of softcopy VOI LUTs in this list.

Returns
  the number of softcopy VOI LUTs.

## ◆ write()

OFCondition DVPSSoftcopyVOI_PList::write | ( | DcmItem & | dset | ) |

writes the list of softcopy VOI LUTs managed by this object to a DICOM dataset.

Copies of the DICOM elements managed by this object are inserted into the DICOM dataset.

Parameters

  dset | the DICOM dataset to which the SoftcopyVOILUTSequence is written

Returns
  EC_Normal if successful, an error code otherwise.

The documentation for this class was generated from the following file:

- dcmpstat/include/dcmtk/dcmpstat/dvpssvl.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1